#include "Template.h"
#include <sys/time.h>
#include <unistd.h>
#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>

int main(int argc,char **argv) {
	timeval start,end;
	double diff,overall=0;
	Template t;
	DataSet  *dset=new DataSet("dset1");  
	DataSet  *dummydset=new DataSet("dummydset");
	DSRow	 *row1,*row2,*row3,*row4;
	row1=new DSRow;
	row2=new DSRow;
	row3=new DSRow;
	row4=new DSRow;
	
	t.addVariable("VAR1","VAR_VAL1");
	t.addVariable("VAR2","VAR_VAL2");
	t.addVariable("VAR3","VAR_VAL3");
	row1->addCell("col1","col1_val1");
	row1->addCell("col2","col2_val1");
	row2->addCell("col1","col1_val2");
	row2->addCell("col2","col2_val2");
	row3->addCell("c1","v1");
	row4->addCell("c1","v2");
	
	dset->addRow(row1);
	dset->addRow(row2);
	dummydset->addRow(row3);
	dummydset->addRow(row4);
	t.addDataSet(dset);
	t.addDataSet(dummydset);
	gettimeofday(&start,0);
	int n=(argc>=2)?atoi(argv[1]):1;
	if(argc>=3) {
		for(int i=2;i<argc;i++) {
			t.setTemplateName(argv[i]);
			for(int j=0;j<n;j++) {
				t.parse();
			}
		}
	} else {
		t.setTemplateName("aa.tmpl");
		for(int i=0;i<n;i++) {
			t.parse();
		}
	}
	gettimeofday(&end,0);
	diff=(end.tv_sec-start.tv_sec)+((double)(end.tv_usec-start.tv_usec))/1000000;
	cerr << "Parsed "<< n << " times in "<<diff<<" seconds\n";
}