#ifndef __TMPL_H_
#define __TMPL_H_

#include <unistd.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <errno.h>
#include <limits.h>

#include "TemplateError.h"

class TemplateContainer {
public:
	TemplateContainer();
	TemplateContainer(const char *t_name);
	~TemplateContainer();	
	int getCurrent() { return cur; }
	void setCurrent(int current) { cur=current; }
	string &getTemplateDir() { return template_dir; }
	char next();
	void prev();
	int line,pos;
private:
	char *tmpl;
	int cur;
	int prev_pos;
	int template_size;
	string template_dir;
};




#endif

