#include "TemplateVariable.h"

TemplateVariable::TemplateVariable() : TemplateObject(VARIABLE) 
{
	val="";
}

TemplateVariable::TemplateVariable(int v) : TemplateObject(VARIABLE) 
{
	setVal(v);

}

TemplateVariable::TemplateVariable(double v) : TemplateObject(VARIABLE) 
{
	setVal(v);	
	
}

TemplateVariable::TemplateVariable(string v) : TemplateObject(VARIABLE) 
{
	setVal(v);
}

TemplateVariable::~TemplateVariable() { }

void TemplateVariable::setVal(int v) {
	char buf[256];
	snprintf(buf,255,"%d",v);
	val=buf;
}

void TemplateVariable::setVal(double v) {
	char buf[256];
	snprintf(buf,255,"%lf",v);
	val=buf;
}

void TemplateVariable::setVal(string v) {
	val=v;
}

string &TemplateVariable::getVal() {
	return val;
}

